backend/urls.py
from django.urls import path
from backend import views

app_name = 'backend'

urlpatterns = [
    path('accounts/signup/', views.signup, name='signup'),
    path('accounts/signup/check/', views.signup_check, name='signup_check'),
    path('accounts/login/', views.login, name='login'),
    path('accounts/login/identify/', views.identify, name='identify'),
    path('accounts/logout/', views.logout, name='logout'),
    path('accounts/verify/', views.verify, name='verify'),
    path('accounts/verify/resend', views.verify_resend, name='verify_resend'),
    path('accounts/recovery/', views.recovery, name='recovery'),
    path('accounts/edit/', views.edit, name='edit'),

    path('interactions/follow/<int:pk>/', views.follow, name='follow'),
    path('interactions/unfollow/<int:pk>/', views.unfollow, name='unfollow'),

    path('interactions/up-vote/<int:pk>/', views.up_vote, name='up_vote'),
    path('interactions/down-vote/<int:pk>/', views.down_vote, name='down_vote'),

    path('thread/<slug>/', views.thread, name='thread'),
    path('thread/<int:pk>/edit/', views.thread_edit, name='thread_edit'),
    path('thread/<int:pk>/delete/', views.thread_delete, name='thread_delete'),
    path('thread/<int:pk>/reply/', views.thread_reply, name='thread_reply'),

    path('report/', views.report, name='report'),
    path('report/<int:pk>/edit', views.report_edit, name='report_edit'),

    path('observation/<int:pk>/reply', views.observation_reply, name='observation_reply'),
    path('observation/names/', views.observation_names, name='observation_names'),

    path('maps/', views.maps, name='maps'),
    path('search/', views.search, name='search'),
    path('language/<code>/', views.language, name='language'),

    path('mail-test/', views.mail_test, name='mail-test'),
]

config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.views.static import serve

urlpatterns = [
    path('', include('frontend.urls')),
    path('api/', include('backend.urls')),
    path('admin/', admin.site.urls),
    path('_nested_admin/', include('nested_admin.urls')),
]

handler404 = 'frontend.views.handler404'
handler500 = 'frontend.views.handler500'

if not settings.DEBUG:
    # static use white noise
    urlpatterns += path('media/<path:path>/', serve, {'document_root': settings.MEDIA_ROOT}),
else:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

frontend/urls.py
from django.urls import path
from django.views import defaults
from frontend import views

app_name = 'frontend'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about'),
    path('team/', views.team, name='team'),
    path('guidelines/', views.guidelines, name='guidelines'),
    path('elasmoid/', views.elasmoid, name='elasmoid'),
    path('iecsn/', views.iecsn, name='iecsn'),
    path('maps/', views.maps, name='maps'),
    path('articles/', views.articles, name='articles'),
    path('articles/<int:pk>/', views.article, name='article'),
    path('report/', views.report, name='report'),
    path('report/tna/', views.report_tna, name='report_tna'),
    path('search/', views.search, name='search'),
    path('s/<slug>/', views.static, name='static'),

    path('signup/', views.signup, name='signup'),
    path('login/', views.login, name='login'),
    path('login/identify/', views.identify, name='identify'),
    path('recovery/', views.recovery, name='recovery'),
    path('verify/', views.verify, name='verify'),

    path('contributor/observations/', views.contributor_observations, name='contributor_observations'),
    path('contributor/observation/<int:pk>/', views.contributor_observation, name='contributor_observation'),
    path('contributor/leaderboard/', views.contributor_leaderboard, name='contributor_leaderboard'),
    path('contributor/profile/', views.contributor_profile, name='contributor_profile'),
    path('contributor/profile/edit/', views.contributor_profile_edit, name='contributor_profile_edit'),
    path('contributor/profile/<username>/', views.contributor_profile_user, name='contributor_profile_user'),

    path('forum/topics/', views.forum_topics, name='forum_topics'),
    path('forum/thread/<int:pk>/', views.forum_thread, name='forum_thread'),
    path('forum/thread/<int:pk>/edit/', views.forum_thread_edit, name='forum_thread_edit'),
    path('forum/threads/<slug>/', views.forum_threads, name='forum_threads'),
    path('forum/threads/<slug>/create', views.forum_thread_create, name='forum_thread_create'),

    path('form/report', views.form_report, name='form_report'),
    path('form/report/<int:pk>/edit', views.form_report_edit, name='form_report_edit'),
]

frontend/models.py
from django.db import models

# Create your models here.

frontend/views.py
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator
from django.db.models import F, Q, Case, Value, When
from django.http import Http404
from django.shortcuts import render, redirect
from urllib.parse import unquote

from backend.models import (
    Observation,
    ObservationImage,
    ObservationReply,
    User,
    UserConnection,
    Topic,
    Thread,
    ThreadReply,
    ThreadVote,
    Article,
    Page,
    Section,
    SectionImage,
    Navigation,
    SubNavigation,
)
from frontend import utils

def static(request, slug):
    lang = utils.get_session_lang(request)    
    template_name = f'{lang}/pages/static/base.html'
    
    pages = Page.objects.filter(slug=slug)

    if not pages.exists():
        raise Http404()
    
    page = pages.first()
    preview = request.GET.get('preview', False)
    
    if not preview and not page.visibility:
        raise Http404()

    mapper = list()
    sections = Section.objects.filter(level=pages.first()).order_by('order')
    for section in sections:
        section_images = SectionImage.objects.filter(level=section).order_by('pk')
        mapper.append((section, section_images))

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'mapper': mapper,
    }

    return render(request, template_name, response)

def home(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/home.html'

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 1,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def about(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/about.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def team(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/team.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def iecsn(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/iecsn.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def guidelines(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/guidelines.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def elasmoid(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/elasmoid.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def report(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def report_tna(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report-tna.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


@login_required
def form_report(request):
    lang = utils.get_session_lang(request)
    user = User.objects.get(username=request.user.username)
    page = 'report.html' if user.is_verified else 'verify.html'
    template_name = f'{lang}/forms/{page}'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def maps(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/maps.html'

    gallery = ObservationImage.objects.filter(observation__status='VERIFIED').order_by('-pk')[:6]
    years = [date.year for date in Observation.objects.dates('datetime', 'year')]

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 5,
        'gallery': gallery,
        'years': years,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def articles(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/articles.html'

    articles = Article.objects.all().order_by('-created_at')
    
    tag = request.GET.get('tag')
    if tag:
        q_objects = Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)
        articles = articles.filter(q_objects).distinct()

    paginator = Paginator(articles, 12)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'tag': tag,
        'paginator_object': paginator_object,
        'page_range': page_range,
    }

    return render(request, template_name, response)


def article(request, pk):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/article.html'
    article = Article.objects.get(pk=pk)
    article_tags = utils.get_article_tags(article, lang)
    article_url =  "{0}://{1}{2}".format(request.scheme, request.get_host(), request.path)

    q_objects = Q()
    for tag in article_tags:
        q_objects |= Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)

    related_articles = Article.objects.all().filter(q_objects).exclude(pk=pk).distinct().order_by('-created_at')[:3]
    
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'article': article,
        'article_url': article_url,
        'related_articles': related_articles,
    }

    return render(request, template_name, response)


def identify(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/identify.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def recovery(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/recovery.html'
    token = request.GET.get('token', None)
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'token': token
    }
    return render(request, template_name, response)


def login(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/login.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def signup(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/signup.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def search(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/search.html'

    observations = Observation.objects.filter(status='VERIFIED').order_by('-created_at')
    observation_images = ObservationImage.objects.all()

    category_shark = observations.filter(category='shark').count()
    category_ray = observations.filter(category='ray').count()
    category_chimaera = observations.filter(category='chimaera').count()

    queries = request.GET.get('query', None)

    if queries:
        queries = unquote(queries)
        for query in queries.split():
            observations = observations.filter(
                Q(common_name__icontains=query) |
                Q(scientific_name__icontains=query) |
                Q(location__icontains=query) |
                Q(province__icontains=query) |
                Q(reporter__first_name__icontains=query) |
                Q(reporter__last_name__icontains=query) |
                Q(submitter__icontains=query)
            )

    category = request.GET.get('category', None)
    if category:
        observations = observations.filter(category=category)

    mapper = list()
    for observation in observations:
        observation_image = None
        images = observation_images.filter(observation=observation)
        if images.exists():
            observation_image = images.first()

        mapper.append((observation, observation_image))

    paginator = Paginator(mapper, 5)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'query': queries,
        'category': category,

frontend/templates/en/pages/forums/thread-create.html
{% extends 'en/en_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="spacer">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a class="no-link c-black" href="{% url 'frontend:forum_topics' %}">Topics</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">
                        <a class="no-link c-blue"
                           href="{% url 'frontend:forum_threads' topic.slug %}">{{ topic.title }}</a>
                    </li>
                </ol>
            </nav>
            <div class="card p-4">
                <form action="{% url 'backend:thread' topic.slug %}" method="post">
                    {% csrf_token %}
                    <input class="form-control mb-3" name="title" id="title" placeholder="Title">
                    <textarea name="content"></textarea>
                    <div class="d-flex justify-content-between">
                        <div>
                            <i class="bi bi-exclamation-circle"></i>
                            <small class="text-muted">
                                Remember, prohibited from containing elements of SARA
                            </small>
                        </div>
                        <button type="submit" class="btn btn-primary mt-2">
                            Submit
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}
{% block js %}
    <script>
        CKEDITOR.replace('content', {
            extraPlugins: 'colorbutton,colordialog'
        });
    </script>
{% endblock %}

frontend/templates/en/pages/forums/thread-edit.html
{% extends 'id/id_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="spacer">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a class="no-link c-black" href="{% url 'frontend:forum_topics' %}">Topics</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">
                        <a class="no-link c-blue"
                           href="{% url 'frontend:forum_threads' thread.topic.slug %}">{{ thread.topic.title }}</a>
                    </li>
                </ol>
            </nav>
            <div class="card p-4">
                <form action="{% url 'backend:thread_edit' thread.pk %}" method="post">
                    {% csrf_token %}
                    <input class="form-control mb-3" name="title" id="title" value="{{ thread.title }}">
                    <textarea name="content">{{ thread.content|safe }}</textarea>
                    <div class="d-flex justify-content-between">
                        <div>
                            <i class="bi bi-exclamation-circle"></i>
                            <small class="text-muted">
                                Remember, prohibited from containing elements of SARA
                            </small>
                        </div>
                        <button type="submit" class="btn btn-primary mt-2">
                            Submit
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}
{% block js %}
    <script>
        CKEDITOR.replace('content', {
            extraPlugins: 'colorbutton,colordialog'
        });
    </script>
{% endblock %}

frontend/templates/en/pages/forums/thread.html
{% extends 'en/en_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="spacer">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a class="no-link c-black" href="{% url 'frontend:forum_topics' %}">Topics</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">
                        <a class="no-link c-blue"
                           href="{% url 'frontend:forum_threads' thread.topic.slug %}">{{ thread.topic.title }}</a>
                    </li>
                </ol>
            </nav>
            <div class="mb-3">
                <h5>
                    {{ thread.title }} <span class="text-muted">#{{ thread.pk }}</span>
                    {% if thread.is_verified %}
                        <i class="bi bi-patch-check-fill c-lightblue-2 ms-2"></i>
                    {% endif %}
                </h5>
                <small class="text-muted mb-5">
                    {{ thread.user.username }} opened this thread on {{ thread.created_at|date:"M d, Y" }}
                </small>
            </div>
            <div class="card mb-3">
                <div class="card-header">
                    <div class="d-flex justify-content-between">
                        <div class="d-flex">
                            {% if thread.user.image %}
                                <img class="avatar-sm" src="{{ thread.user.image.url }}"/>
                            {% else %}
                                <img class="avatar-sm" src="{% static 'images/common/placeholder.jpeg' %}"
                                     alt="placeholder"/>
                            {% endif %}
                            <small class="ms-3">
                                {{ thread.user.username }} posted on {{ thread.created_at|date:"M d, Y" }}
                            </small>
                        </div>
                        {% if request.user == thread.user %}
                            <div class="d-flex">
                                <a href="{% url 'frontend:forum_thread_edit' thread.pk %}" class="c-black me-3">
                                    <i class="bi bi-pencil-square"></i>
                                </a>
                                <a data-bs-toggle="modal" data-bs-target="#deleteConfirmation" class="c-red">
                                    <i class="bi bi-trash"></i>
                                </a>
                            </div>
                        {% endif %}
                    </div>
                </div>
                <div class="card-body">
                    <div class="card-text">
                        {{ thread.content|safe }}
                    </div>
                </div>
                <div class="card-footer">
                    <div class="d-flex justify-content-end">
                        <a href="{% url 'backend:up_vote' thread.pk %}" class="no-link c-black">
                            <div class="d-flex align-items-center">
                                {% if thread_user_vote == True %}
                                    <i class="bi bi-hand-thumbs-up-fill c-green me-2"></i>
                                {% else %}
                                    <i class="bi bi-hand-thumbs-up me-2"></i>
                                {% endif %}
                                <small>{{ thread_up_vote }}</small>
                            </div>
                        </a>
                        <a href="{% url 'backend:down_vote' thread.pk %}" class="no-link c-black">
                            <div class="d-flex align-items-center ms-3">
                                {% if thread_user_vote == False %}
                                    <i class="bi bi-hand-thumbs-down-fill c-red me-2"></i>
                                {% else %}
                                    <i class="bi bi-hand-thumbs-down me-2"></i>
                                {% endif %}
                                <small>{{ thread_down_vote }}</small>
                            </div>
                        </a>
                    </div>
                </div>
            </div>
            {% for reply in thread_replies %}
                <div class="card mb-3">
                    <div class="card-header">
                        <div class="d-flex">
                            {% if reply.user.image %}
                                <img class="avatar-sm" src="{{ reply.user.image.url }}"/>
                            {% else %}
                                <img class="avatar-sm" src="{% static 'images/common/placeholder.jpeg' %}"
                                     alt="placeholder"/>
                            {% endif %}
                            <small class="ms-3">
                                {{ reply.user.username }} commented on {{ reply.created_at|date:"M d, Y" }}
                            </small>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="card-text">
                            {{ reply.content|safe }}
                        </div>
                    </div>
                </div>
            {% endfor %}
            <div class="card mb-3">
                <div class="card-body">
                    <h6 class="mb-3">Reply</h6>
                    <form action="{% url 'backend:thread_reply' thread.pk %}" method="post">
                        {% csrf_token %}
                        <textarea name="content" id="content"></textarea>
                        <button type="submit" class="btn btn-primary mt-2 float-end">
                            Submit
                        </button>
                    </form>
                </div>
            </div>
    </section>
    <div class="modal fade" id="deleteConfirmation" tabindex="-1" aria-labelledby="deleteConfirmationLabel"
         aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="deleteConfirmationLabel">Delete Thread</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    Are you sure you want to delete this thread?
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Close</button>
                    <a href="{% url 'backend:thread_delete' thread.pk %}" class="no-link">
                        <button type="button" class="btn btn-danger">Delete</button>
                    </a>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
{% block js %}
    <script>
        CKEDITOR.replace('content', {
            extraPlugins: 'colorbutton,colordialog'
        });
    </script>
{% endblock %}

frontend/templates/en/pages/forums/threads.html
{% extends 'en/en_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="spacer">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a class="no-link c-blue" href="{% url 'frontend:forum_topics' %}">Topics</a>
                    </li>
                    <li class="breadcrumb-item"></li>
                </ol>
            </nav>
            <div class="d-flex justify-content-between">
                <h3 class="mb-5">
                    Threads
                </h3>
                <div>
                    <a href="{% url 'frontend:forum_thread_create' topic.slug %}"
                       class="btn btn-success btn-sm">
                        New Thread
                    </a>
                </div>
            </div>
            <div class="list-group">
                {% for thread, num_reply in mapper %}
                    <a href="{% url 'frontend:forum_thread' thread.pk %}"
                       class="list-group-item list-group-item-action">
                        <div class="d-flex justify-content-between">
                            <div class="d-flex align-items-center">
                                <i class="bi bi-record-circle c-green"></i>
                                <div class="ms-3">
                                    <span>
                                        {{ thread.title }}
                                        {% if thread.is_verified %}
                                            <i class="bi bi-patch-check-fill c-lightblue-2 ms-2"></i>
                                        {% endif %}
                                    </span>
                                    <br/>
                                    <small class="text-muted">
                                        #{{ thread.pk }} opened on {{ thread.created_at|date:"M d, Y" }}
                                        by {{ thread.user.username }}
                                    </small>
                                </div>
                            </div>
                            <div class="d-flex">
                                <i class="bi bi-chat-left"></i>
                                <small class="text-muted ms-2">{{ num_reply }}</small>
                            </div>
                        </div>
                    </a>
                {% endfor %}
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}

{% endblock %}

frontend/templates/en/pages/forums/topics.html
{% extends 'en/en_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="spacer">
            <h3 class="mb-5">
                Topics
            </h3>
            <div class="row row-cols-1 row-cols-md-3 g-4 py-3">
                {% for topic, num_thread in trending_topics %}
                    <a class="no-link c-black" href="{% url 'frontend:forum_threads' topic.slug %}">
                        <div class="col">
                            <div class="card">
                                {% if topic.image %}
                                    <img src="{{ topic.image.url }}" class="card-img-top"/>
                                {% else %}
                                    <img src="{% static 'images/common/icons/forum.png' %}" class="card-img-top"/>
                                {% endif %}
                                <div class="card-body">
                                    <div class="text-center">
                                        <h5 class="card-title">{{ topic.title }}</h5>
                                        <p class="card-text">
                                            {{ topic.description }}
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                {% endfor %}
            </div>
        </div>
        <div class="spacer">
            <h4 class="mb-5">
                All Topics
            </h4>
            <div class="row">
                {% for topic in topics %}
                    <a class="no-link c-black" href="{% url 'frontend:forum_threads' topic.slug %}">
                        <div class="col-xs-12 col-lg-8">
                            <div class="card mb-3">
                                <div class="row g-0">
                                    <div class="col-md-4">
                                        {% if topic.image %}
                                            <img src="{{ topic.image.url }}" class="img-fluid rounded-start"/>
                                        {% else %}
                                            <img src="{% static 'images/common/icons/forum.png' %}"
                                                 class="img-fluid rounded-start"/>
                                        {% endif %}
                                    </div>
                                    <div class="col-md-8">
                                        <div class="card-body">
                                            <h5 class="card-title">{{ topic.title }}</h5>
                                            <p class="card-text">
                                                {{ topic.description }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                {% endfor %}
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}

{% endblock %}